//----------------------------------------------------------------------------
//ubb tags
function changeAsUbb(str)
{
	return str.replace(/<(\/?)(b|i|u)>/ig,'[$1$2]')
		.replace(/<(\/?)strong>/ig, '[$1b]')
		.replace(/<(\/?)em>/ig, '[$1i]')
		.replace(/<\/?p[^>]*>/ig, '\r\n')
		.replace(/<\/?div[^>]*>/ig, '\r\n')
		.replace(/<\/?br[^>]*>/ig, '\r\n')
		.replace(/<h3 [^>]*?split_page[^>]*>(.*?)<\/h3>/ig, '[pagetitle]$1[/pagetitle]')
		.replace(/<(\/?)h[1-6][^>]*>/ig, '[$1$2]')
		.replace(/<img( [^>]+?)\/?>/ig, __cbChangeImg)
		.replace(/<font( [^>]+?)>(.+?)<\/font>/ig, __cbChangeFont)
		.replace(/<font( [^>]+?)>(.+?)<\/font>/ig, __cbChangeFont)
		.replace(/<font( [^>]+?)>(.+?)<\/font>/ig, __cbChangeFont)
		//.replace(/<span( [^>]*? stlye="background\-color:\s*r)>(.+?)<\/span>/ig, __cbChangeBG)
		.replace(/<(\/?)[a-z0-9]+[^>]*>/ig, '')
		.replace(/&nbsp;/g, ' ')
		.replace(/&lt;/g, '<')
		.replace(/&gt;/g, '>')
		.replace(/&amp;/g, '&');//删除未知的html标签
}
function __cbChangeFont(strAll, str1,str2)
{
	var tagBegin='',tagEnd='';
	var r= new RegExp('[^\\w]color\\s*=\\s*["\']?([\#a-z0-9]+)','i');
	if(res=r.exec(str1)){
		tagBegin +='[color='+res[1]+']';
		tagEnd +='[/color]';
	}
	r= new RegExp('[^\\w]size\\s*=\\s*["\']?(\\d+)','i');
	if(res=r.exec(str1)){
		tagBegin +='[size='+res[1]+']';
		tagEnd +='[/size]';
	}
	r= new RegExp('[^\\w]background\\-color:\\s*(\\#?\\w+)','i');
	if(res=r.exec(str1)){
		tagBegin +='[bg='+res[1]+']';
		tagEnd +='[/bg]';
	}
	return tagBegin+str2+tagEnd;
}
function __cbChangeImg(strAll, str1)
{
	var w=0,h=0,src='',res=null;
	var r= new RegExp('[^\\w]emot\\s*=\\s*["\']?(\\d+)','i');
	if(res=r.exec(str1)){
		return '[:'+res[1]+']';//face
	}
	r= new RegExp('[^\\w]width\\s*=\\s*["\']?(\\d+)','i');
	if(res=r.exec(str1)){
		w=res[1];
	}
	r= new RegExp('[^\\w]height\\s*=\\s*["\']?(\\d+)','i');
	if(res=r.exec(str1)){
		h=res[1];
	}
	r= new RegExp('[^\\w]src\\s*=\\s*["\']?([^\s"\']+)','i');
	if(res=r.exec(str1)){
		src=res[1];
	}
	if(''==src){
		return '';
	}
	if(w && h){
		return '[img='+w+','+h+']'+src+'[/img]';
	}else{
		return '[img]'+src+'[/img]';
	}
}

//table,tr,td,th,b,u,i,img,url,list,:#,color,size,bg,code, \n
function changeAsHtml(str)
{
	var remainInStr=str, outStr='',innerStr='', nl2br=true, keep=false, result=null;
	var ubbReg= new RegExp('\\[(:\\d+|\\/[a-z]\\w*|[a-z]\\w*(?:=([^\\]\\s]+))?)\\]','i');
	
	var escapeHtml=function(s){return s.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/  /g, ' &nbsp;').replace(/\r\n/g, '<br />');}

	while( null != (result = ubbReg.exec(remainInStr))){
		innerStr = remainInStr.substr(0, result.index);
		remainInStr = remainInStr.substr(result.index + result[0].length);
		
		outStr +=escapeHtml(innerStr);		

		if(':'==result[1].substr(0,1)){//emot
			var emot = result[1].substr(1, 1000);
			outStr+='<img src="'+tqEditor.url+'face/'+emot+'.gif" emot='+emot+' />'
		}else{
			var tag = result[1].toLowerCase();
			if(result[2]) tag = tag.substr(0,tag.indexOf('=')); 
			switch(tag){
				case 'code' :  keep=true;
					break;
				case '/code' : 
					keep=false;
					break;
				case 'b' : case '/b': 
				case 'i' : case '/i': 
				case 'u' : case '/u': outStr+='<'+tag+'>';break;

				case 'color' : outStr+='<font color="'+result[2]+'" >';break;
				case '/color' : outStr+='</font>';break;

				case 'size' : outStr +='<font size="'+result[2]+'" >';break;
				case '/size' : outStr+='</font>';break;
				
				case 'bg' :  outStr +='<font style="background-color:'+result[2]+'" >';break;
				case '/bg' : outStr+='</font>';break;

				case 'img': outStr +='<img src="'; break;
				case '/img': outStr +='" />';break;
				case 'url':break;
				case '/url':break;

			}
		}

	}
	outStr+=escapeHtml(remainInStr);
	return outStr;
}